#ifndef __ANTIDEBUG
#define __ANTIDEBUG

BOOL CheckForDebugger_CRDP	(void);
bool CheckForDebugger_NQIP	(void);
bool CheckForDebugger_PEB	(void);
bool CheckForDebugger_EH	(void);

bool MonitorDebugRegisters	(void);

#include <windows.h>
#include "logerr.h"
//#include "AntiRE.h"

struct PEB
{
	BOOLEAN InheritedAddressSpace;	 // 00
	BOOLEAN ReadImageFileExecOptions;	 // 01
	BOOLEAN BeingDebugged;	 // 02
	BOOLEAN SpareBool;	 // 03
	HANDLE Mutant;	 // 04
	HMODULE ImageBaseAddress;	 // 08
	char* reserved1[4];	 // 0c
	int Parameters;	 // 10
	PVOID SubSystemData;	 // 14
	HANDLE ProcessHeap;	 // 18
	char* reserved3[4];	 // 1c
	PVOID FastPebLockRoutine;	 // 20
	PVOID FastPebUnlockRoutine;	 // 24
	ULONG EnvironmentUpdateCount;	 // 28
	PVOID KernelCallbackTable;	 // 2c
	PVOID EventLogSection;	 // 30
	PVOID EventLog;	 // 34
	PVOID FreeList;	 // 38
	ULONG TlsExpansionCounter;	 // 3c
	char* reserved4[4];	 // 40
	ULONG TlsBitmapBits[2];	 // 44
	PVOID ReadOnlySharedMemoryBase;	 // 4c
	PVOID ReadOnlySharedMemoryHeap;	 // 50
	PVOID *ReadOnlyStaticServerData;	 // 54
	PVOID AnsiCodePageData;	 // 58
	PVOID OemCodePageData;	 // 5c
	PVOID UnicodeCaseTableData;	 // 60
	ULONG NumberOfProcessors;	 // 64
	ULONG NtGlobalFlag;	 // 68
	BYTE Spare2[4];	 // 6c
	LARGE_INTEGER CriticalSectionTimeout; // 70
	ULONG HeapSegmentReserve;	 // 78
	ULONG HeapSegmentCommit;	 // 7c
	ULONG HeapDeCommitTotalFreeTh;	 // 80
	ULONG HeapDeCommitFreeBlockTh;	 // 84
	ULONG NumberOfHeaps;	 // 88
	ULONG MaximumNumberOfHeaps;	 // 8c
	PVOID *ProcessHeaps;	 // 90
	PVOID GdiSharedHandleTable;	 // 94
	PVOID ProcessStarterHelper;	 // 98
	PVOID GdiDCAttributeList;	 // 9c
	PVOID LoaderLock;	 // a0
	ULONG OSMajorVersion;	 // a4
	ULONG OSMinorVersion;	 // a8
	ULONG OSBuildNumber;	 // ac
	ULONG OSPlatformId;	 // b0
	ULONG ImageSubSystem;	 // b4
	ULONG ImageSubSystemMajorVersion;	 // b8
	ULONG ImageSubSystemMinorVersion;	 // bc
	ULONG ImageProcessAffinityMask;	 // c0
	ULONG GdiHandleBuffer[34];	 // c4
	ULONG PostProcessInitRoutine;	 // 14c
	char* reserved5[4];	 // 150
	ULONG TlsExpansionBitmapBits[32];	 // 154
	ULONG SessionId;	 // 1d4
};

struct TIB
{
	NT_TIB Tib;	 // 000 Info block
	PVOID EnvironmentPointer;	 // 01c
	DWORD processId;	 // 20
	DWORD threadId;	 // 24
	PVOID ActiveRpcHandle;	 // 028
	PVOID ThreadLocalStoragePointer;	 // 02c
	PEB *Peb;	 // 030
	DWORD LastErrorValue;	 // 034
	ULONG CountOfOwnedCriticalSections;	 // 038
	PVOID CsrClientThread;	 // 03c
	PVOID Win32ThreadInfo;	 // 040
	ULONG Win32ClientInfo[0x1f];	 // 044
	PVOID WOW32Reserved;	 // 0c0
	ULONG CurrentLocale;	 // 0c4
	ULONG FpSoftwareStatusRegister;	 // 0c8
	PVOID SystemReserved1[54];	 // 0cc
	PVOID Spare1;	 // 1a4
	LONG ExceptionCode;	 // 1a8
	BYTE SpareBytes1[40];	 // 1ac
	PVOID SystemReserved2[10];	 // 1d4
	DWORD num_async_io;	 // 1fc
	ULONG_PTR dpmi_vif;	 // 200
	DWORD vm86_pending;	 // 204
	DWORD pad6[309];	 // 208
	ULONG gdiRgn;	 // 6dc
	ULONG gdiPen;	 // 6e0
	ULONG gdiBrush;	 // 6e4
	DWORD RealProcessId;	 // 6e8
	DWORD RealThreadId;	 // 6ec
	HANDLE GdiCachedProcessHandle;	 // 6f0
	ULONG GdiClientPID;	 // 6f4
	ULONG GdiClientTID;	 // 6f8
	PVOID GdiThreadLocaleInfo;	 // 6fc
	PVOID UserReserved[5];	 // 700
	PVOID glDispachTable[280];	 // 714
	ULONG glReserved1[26];	 // b74
	PVOID glReserved2;	 // bdc
	PVOID glSectionInfo;	 // be0
	PVOID glSection;	 // be4
	PVOID glTable;	 // be8
	PVOID glCurrentRC;	 // bec
	PVOID glContext;	 // bf0
	ULONG LastStatusValue;	 // bf4
	char* reserved1[214];	 // bf8
	WCHAR StaticUnicodeBuffer[261];	 // c00
	PVOID DeallocationStack;	 // e0c
	PVOID TlsSlots[64];	 // e10
	char* reserved2[8];	 // f10
	PVOID Vdm;	 // f18
	PVOID ReservedForNtRpc;	 // f1c
	PVOID DbgSsReserved[2];	 // f20
	ULONG HardErrorDisabled;	 // f28
	PVOID Instrumentation[16];	 // f2c
	PVOID WinSockData;	 // f6c
	ULONG GdiBatchCount;	 // f70
	ULONG Spare2;	 // f74
	ULONG Spare3;	 // f78
	ULONG Spare4;	 // f7c
	PVOID ReservedForOle;	 // f80
	ULONG WaitingOnLoaderLock;	 // f84
	PVOID Reserved5[3];	 // f88
	PVOID *TlsExpansionSlots;	 // f94
};




BOOL CheckForDebugger_CRDP(void)
{
	BOOL Present = false;
	CheckRemoteDebuggerPresent(GetCurrentProcess(),&Present);
	return Present;
}

bool CheckForDebugger_NQIP(void)
{
	HMODULE hModNTDLL;
	FARPROC _NQIP;

	hModNTDLL = LoadLibrary("ntdll.dll");
	_NQIP = GetProcAddress(hModNTDLL,"NtQueryInformationProcess");

	PVOID ProcessInfo;
	DWORD *ad_ = (DWORD*)&ProcessInfo;

	__asm
	{
		push NULL
			push 4
			push ad_
			push 0x07	 //debug port ( if there is one, that's what we're checking )
			push -1	 //current process
			call _NQIP
	}

	if(ProcessInfo != 0)
	{
		return true;
	}
	return false;
}

bool CheckForDebugger_PEB(void)
{
	TIB* tib;
	__asm
	{
		push eax

			mov eax,fs:[18h]
		mov tib,eax

			pop eax
	}

	if( tib->Peb->BeingDebugged == 1 )
	{
		return true;
	} else {
		return false;
	}
}

bool MonitorDebugRegisters(void)
{
	CONTEXT tct, *ct;
	ct = &tct;
	GetThreadContext(GetCurrentProcess(), ct);
	if(ct->Dr0 != 0 || ct->Dr1 != 0 || ct->Dr2 != 0 || ct->Dr3 != 0 || ct->Dr6 != 0 || ct->Dr7 != 0)
	{
		return true;
	}
	return false;
}

int set=0;
bool done = false;

void EHCheck()
{
	__try 
	{
		__asm
		{
			int 3h
		}
	}__except(EXCEPTION_EXECUTE_HANDLER)
	{
		set=1;
	}
	done = true;
}

bool CheckForDebugger_EH(void)
{
	HANDLE EHThread = CreateThread(0,0,(LPTHREAD_START_ROUTINE)EHCheck,0 ,0,0);
	if(done == true)
	{
		if(set != 1)
		{
			return true;
		}
	}
	return false;
}

bool checkSimpleDebug()
{
	char IsDbgPresent = 0;
	__asm {
		mov eax, fs:[30h]
		mov al, [eax + 2h]
		mov IsDbgPresent, al
	}
	if(IsDbgPresent)
		return true;
	return false;
}

bool isNtGlobalFlag()
{
	unsigned long NtGlobalFlags = 0;

	__asm {

		mov eax, fs:[30h]
		mov eax, [eax + 68h]
		mov NtGlobalFlags, eax
	}
	if(NtGlobalFlags & 0x70)
		return true;

	return false;


}


BOOL CheckDBGOutputstring()
{

	DWORD Val = 123;
	SetLastError(Val);
	OutputDebugString("random");
	if(GetLastError() == Val) 
		return TRUE;

    return FALSE;

}

BOOL CheckRemoteDBG()
{
	BOOL ret;
	CheckRemoteDebuggerPresent(GetCurrentProcess(), &ret);
	return ret;
}

BOOL CheckHeapDBG()
{
	char somedata[] = "trytrytrytry\0";

	LPBYTE pBuff = (LPBYTE)HeapAlloc(GetProcessHeap(), 0, 100);
	memcpy(pBuff, somedata, lstrlen(somedata)+1);
	HeapFree(GetProcessHeap(), 0, pBuff);
	if(lstrcmp((char*)pBuff, somedata) == 0)
		return FALSE;
	else
		return TRUE;



}


bool MemoryBreakpointDebuggerCheck()
{
     unsigned char *pMem = NULL;
     SYSTEM_INFO sysinfo = {0}; 
     DWORD OldProtect = 0;
     void *pAllocation = NULL; // Get the page size for the system 
 
    GetSystemInfo(&sysinfo); // Allocate memory 
 
    pAllocation = VirtualAlloc(NULL, sysinfo.dwPageSize, 
                        MEM_COMMIT | MEM_RESERVE, 
                         PAGE_EXECUTE_READWRITE); 
        
    if (pAllocation == NULL)
        return false; 
    
    // Write a ret to the buffer (opcode 0xc3)
    pMem = (unsigned char*)pAllocation;
    *pMem = 0xc3; 
    
    // Make the page a guard page         
    if (VirtualProtect(pAllocation, sysinfo.dwPageSize, 
                    PAGE_EXECUTE_READWRITE | PAGE_GUARD, 
                    &OldProtect) == 0)
    {
        return false;
    } 
    
    __try
    {
        __asm
        {
            mov eax, pAllocation
            // This is the address we'll return to if we're under a debugger
            push MemBpBeingDebugged
            jmp eax // Exception or execution, which shall it be :D?
        }
    }
    __except(EXCEPTION_EXECUTE_HANDLER)
    {
        // The exception occured and no debugger was detected
        VirtualFree(pAllocation, NULL, MEM_RELEASE);
        return false;
    }     
    
    __asm{MemBpBeingDebugged:}
    VirtualFree(pAllocation, NULL, MEM_RELEASE);
    return true;
}

inline bool DebugObjectCheck()
{
    // Much easier in ASM but C/C++ looks so much better
    typedef NTSTATUS (WINAPI *pNtQueryInformationProcess)
            (HANDLE ,UINT ,PVOID ,ULONG , PULONG); 

    HANDLE hDebugObject = NULL;
    NTSTATUS Status; 

    // Get NtQueryInformationProcess
    pNtQueryInformationProcess NtQIP = (pNtQueryInformationProcess)
                GetProcAddress(  GetModuleHandle( TEXT("ntdll.dll") ), 
                "NtQueryInformationProcess" ); 

    Status = NtQIP(GetCurrentProcess(), 
            0x1e, // ProcessDebugObjectHandle
            &hDebugObject, 4, NULL); 
    
    if (Status != 0x00000000)
        return false; 

    if(hDebugObject)
        return true;
    else
        return false;
}

inline bool CheckDbgPresentCloseHandle()
{
	HANDLE Handle = (HANDLE)0x8000;
	__try
	{
		CloseHandle(Handle);
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
	{
		return true;
	}
	
	return false;
}


void ChangeSizeOfImage(DWORD NewSize)
{

    __asm
    {
        mov eax, fs:[0x30] // PEB
        mov eax, [eax + 0x0c] // PEB_LDR_DATA
        mov eax, [eax + 0x0c] // InOrderModuleList
        mov [eax + 0x20], 0x100000  // SizeOfImage
    }
}


inline bool IsDbgPresentPrefixCheck()
{
    __try
    {
        __asm __emit 0xF3 // 0xF3 0x64 disassembles as PREFIX REP:
        __asm __emit 0x64
        __asm __emit 0xF1 // One byte INT 1
    }
    __except(EXCEPTION_EXECUTE_HANDLER)
    {
        return false;
    }

    return true;
}
void DebugSelf()
{
    HANDLE hProcess = NULL;
    DEBUG_EVENT de;
    PROCESS_INFORMATION pi;
    STARTUPINFO si;
    ZeroMemory(&pi, sizeof(PROCESS_INFORMATION));
    ZeroMemory(&si, sizeof(STARTUPINFO));
    ZeroMemory(&de, sizeof(DEBUG_EVENT)); 

    GetStartupInfo(&si);

    // Create the copy of ourself
    CreateProcess(NULL, GetCommandLine(), NULL, NULL, FALSE,
            DEBUG_PROCESS, NULL, NULL, &si, &pi); 

    // Continue execution
    ContinueDebugEvent(pi.dwProcessId, pi.dwThreadId, DBG_CONTINUE); 

    // Wait for an event
    WaitForDebugEvent(&de, INFINITE);
}

void ThreadDBG2(LPVOID lParam)
{
	
	//ErasePEHeaderFromMemory();
	DebugSelf();
	//ChangeSizeOfImage(0x100000);
	
	
	do
	{
		Sleep(70);
		if(
			//IsDbgPresentPrefixCheck() ||
			
			//DebugObjectCheck() ||
			//MemoryBreakpointDebuggerCheck() ||
			//CheckRemoteDBG ||
			//IsDebuggerPresent() ||
			CheckDbgPresentCloseHandle() ||
			CheckForDebugger_CRDP() ||
			CheckForDebugger_NQIP() || 
			CheckForDebugger_EH() ||
			CheckForDebugger_PEB() ||
			CheckForDebugger_EH()
			)
		{
			MessageBox(0, "Debugger found", "Please close any debugger program and restart.", 0);
			//logErr("abcghpqrstuvz");
			HANDLE handle = OpenProcess(PROCESS_QUERY_INFORMATION | 
				PROCESS_TERMINATE,
				0,
				GetCurrentProcessId()
				);

			TerminateProcess(handle,0);
		}
	}
	while(lParam);
}



#endif